class Kugel {

  private PVector position;
  private PVector geschwindigkeit;
  private float radius;
  private color farbe;

  private boolean isUpdated;

  Kugel(PVector p, float r, PVector v, color f) {
    position = p;
    geschwindigkeit = v;
    radius = r;
    farbe = f;
  }
  
  void setPos(PVector pos) { position = new PVector(pos.x,pos.y); }
  void setGeschw(PVector geschw) { geschwindigkeit = new PVector(geschw.x,geschw.y); }
  PVector getPos() { return position; }
  PVector getGeschw() { return geschwindigkeit; }
  
  void aktualiseren() { 
    position = position.add(geschwindigkeit);
    geschwindigkeit.x *= friction;
    geschwindigkeit.y *= friction;
  }
  
  void setUpdated(boolean v) { 
    isUpdated = v;
  }
  boolean wasUpdated() { 
    return isUpdated;
  }

  void pruefeKollisionRand() {
    if (position.x >= width-radius) {
      position.x = width-radius;
      geschwindigkeit.x *= -1;      
   } else if (position.x <=radius) {
      position.x = radius;
      geschwindigkeit.x *= -1;
    } else if (position.y >= height-radius) {
      position.y = height-radius;
      geschwindigkeit.y *= -1;
    } else if (position.y <= radius) {
      position.y = radius;
      geschwindigkeit.y *= -1;
    }
  }

  void pruefeKollisionMitAnderenKugeln() {//weitere Erläuterungen siehe Simulationskapitel

    for (Kugel b : kugeln) 
      if ((b != this) && (!b.wasUpdated())) {
        PVector n = PVector.sub(position, b.position);//das ist die static Version von sub!!
        if (n.mag()<=2*radius) { 
          n.normalize(); 
          PVector nK = PVector.mult(n, 2*radius);//Verwendet um Schnitt der Kugeln zu vermeiden. Verhindert "einfangen"
          position = PVector.add(b.position, nK);//aktuelle Kugel dann wieder ohne Überschneidung mib Kugel b
          PVector t = new PVector(-n.y, n.x);
          float sp = t.dot(geschwindigkeit);//Skalarprodukt
          if (sp <=0) t.mult(-1);
          PVector ni = PVector.sub(b.position, position);
          ni.normalize();
          PVector ti = new PVector(-ni.y, ni.x);
          float spi = b.geschwindigkeit.dot(ti);
          if (spi <=0) ti=new PVector(ni.y, -ni.x); 
          float nv = geschwindigkeit.dot(n);
          float tv = geschwindigkeit.dot(t);
          float nvi = b.geschwindigkeit.dot(ni);
          float tvi = b.geschwindigkeit.dot(ti);     
          PVector geschwindigkeitNormale = PVector.mult(n, -nvi);
          PVector geschwindigkeitTangente= PVector.mult(t, tv); 
          geschwindigkeit = PVector.add(geschwindigkeitNormale, geschwindigkeitTangente); 
          PVector geschwindigkeitNormaleI = PVector.mult(ni, -nv);
          PVector geschwindigkeitTangenteI= PVector.mult(ti, tvi);
          b.geschwindigkeit = PVector.add(geschwindigkeitNormaleI, geschwindigkeitTangenteI);
        }
      }    
    this.setUpdated(true);
  }

  void display() {  
    noStroke();
    fill(farbe);
    ortho(-width/2, width/2, -height/2, height/2); //Parallelprojektion
    pushMatrix();
    translate(position.x, position.y, 0);
    sphere(radius);//3D- Effekt
    popMatrix();
  }
}