//////////////////////////////////////////////////
//Aufgabe 4 im Simulationskapitel
/////////////////////////////////////////////////

ArrayList<Kugel> kugeln;
ArrayList<Tasche> taschen;
float abstand;
 
float friction = 0.995;
float ballGeschw = 20;

void setup() {
  size(1000, 500, P3D);
  kugeln = new ArrayList<Kugel>();
  kugeln.add(new Kugel(new PVector(100, 250), 20, new PVector(0, 0), color(255))); //weiße Kugel
  kugeln.add(new Kugel(new PVector(300, 270), 20, new PVector(0, 0), color(0, 0, 255)));
  kugeln.add(new Kugel(new PVector(300, 230), 20, new PVector(0, 0), color(255, 255, 0)));
  
  kugeln.add(new Kugel(new PVector(340, 210), 20, new PVector(0, 0), color(255, 0, 255)));
  kugeln.add(new Kugel(new PVector(340, 250), 20, new PVector(0, 0), color(0, 255, 255)));
  kugeln.add(new Kugel(new PVector(340, 290), 20, new PVector(0, 0), color(255, 0, 0)));
  
  kugeln.add(new Kugel(new PVector(380, 190), 20, new PVector(0, 0), color(186, 114, 101)));//braune Kugel
  kugeln.add(new Kugel(new PVector(380, 270), 20, new PVector(0, 0), color(56, 186, 52))); //grüne Kugel
  kugeln.add(new Kugel(new PVector(380, 230), 20, new PVector(0, 0), color(242, 114, 26)));//orange Kugel
  kugeln.add(new Kugel(new PVector(380, 310), 20, new PVector(0, 0), color(65, 134, 186)));//blaue Kugel
  
  taschen = new ArrayList<Tasche>();
  taschen.add(new Tasche(new PVector(0,0),70));
  taschen.add(new Tasche(new PVector(500,0),50)); 
  taschen.add(new Tasche(new PVector(1000,0),70));
  taschen.add(new Tasche(new PVector(1000,500),50));
  taschen.add(new Tasche(new PVector(500,500),50));
  taschen.add(new Tasche(new PVector(0,500),70));
  
}


void mouseClicked() {
  if (mouseButton == LEFT) {  
    kugeln.get(0).setPos(new PVector(mouseX, mouseY));
    kugeln.get(0).setGeschw(new PVector(0, 0));
  } else { 
    PVector geschw = new PVector(mouseX-kugeln.get(0).getPos().x, mouseY-kugeln.get(0).getPos().y); 
    geschw.normalize();
    geschw.mult(ballGeschw);
    kugeln.get(0).setGeschw(geschw);
  }
}

void draw() {  
  background(0,120,0);
  lights();
  for (Kugel b : kugeln) b.setUpdated(false);//alle Kugeln wieder nicht-upgedatet
 
  for (Kugel b : kugeln) {
    b.aktualiseren();
    b.display();
    b.pruefeKollisionRand();
    b.pruefeKollisionMitAnderenKugeln();
  }
  
  for(int i = kugeln.size()-1; i>=0;i--){
    Kugel kugel = kugeln.get(i);
    for(Tasche t : taschen){
       if(kugel != null){
          PVector n = PVector.sub(kugel.getPos(), t.getPos());//static Version von sub
          abstand = n.mag();
          if(abstand < 40) {
            if(i==0) { //weiße Kugel auf den Tisch legen, falls sie in eine Tasche fällt
              kugeln.get(i).setPos(new PVector(100, 250));
              kugeln.get(i).setGeschw(new PVector(0, 0));
            }else { kugeln.remove(i);}//Kugel in eine Tasche gefallen und damit entfernt
           
          }
       }
    
    }
  }
  
  for (Tasche t : taschen) {
    t.display();
  }
  
  
}